﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Drawing;
using System.IO;
using System.Media;
using System.Windows.Media;
using GTA;

namespace MissionScreen
{
    class MainClass : Script
    {
        public Texture MissionPassedTexture;

        //Settings
        float scale = 1;
        int duration = 5000;

        public MainClass()
        {
            base.Interval = 10;
            this.Tick += MainClass_Tick;
            MissionPassedTexture = new Texture(File.ReadAllBytes(".\\scripts\\V Hud\\missionpassed.png"));

            ReadSettings();
        }

        private void ReadSettings()
        {
            scale = Settings.GetValueFloat("Scale", "General", 1);
            duration = Settings.GetValueInteger("Duration", "General", 5000);
        }

        /// <summary>
        /// Main tick of this class. Checks if the Mission Completed Song is playing
        /// </summary>
        private void MainClass_Tick(object sender, EventArgs e)
        {
            try
            {
                if (GTA.Native.Function.Call<bool>("IS_MISSION_COMPLETE_PLAYING", new GTA.Native.Parameter("")))
                {
                    base.PerFrameDrawing += DrawMissionPassedTexture;
                    this.Wait(duration);
                    base.PerFrameDrawing -= DrawMissionPassedTexture;
                }
            }
            catch (Exception ex)
            {
                // DEBUG
                //Game.DisplayText(ex.Message, 10000);
            }
        }

        /// <summary>
        /// Draws the Mission Passed Texture
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e">Graphics</param>
        private void DrawMissionPassedTexture(object sender, GraphicsEventArgs e)
        {
            e.Graphics.DrawSprite(MissionPassedTexture, 
                Screen.PrimaryScreen.WorkingArea.Width / 2, 
                Screen.PrimaryScreen.WorkingArea.Height / 2, 
                1000 * scale, 390 * scale, 0);
        }
    }
}
